
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.io.InputStreamReader;
import java.io.BufferedReader;

/**
 *
 * @author nicolas
 */
public class FartShell {

    private static Fart fart;
    // Computo del algoritmo FART para las coordenadas (x,y)
    public static void main(String args[]) {
        try {
        // Si no se ingresaron datos de configuración para el algoritmo de FART
        // se usan los valores por defecto
        if (args.length == 0) {
            System.out.println("\nYou have not entered a value for the variables ALPHA, BETA and RHO.");
            System.out.println("The default value of these variables is:");
            System.out.println("ALPHA = 0.000001, BETA = 1 and RHO = 0.95\n");
            fart = new Fart();
        }

        // Si la cantidad de parametro fue mal intresada el programa termina
        // Se imprime un mensaje de ayuda
        if ( (args.length == 1) && (args.length == 2) && (args.length > 3)) {
            System.out.println("\nYou should enter the value of three parameters, ALPHA, BETA and RHO.");
            System.out.println("Please, re-execute the program by entering a value for ALPHA, BETA and RHO \n separated by spaces:");
            System.out.println("java FartShell <ALPHA> <BETA> <RHO>\n");
            System.exit(0);
        }
        // Se ejecuta el algoritmo de FART con valores de Alpha, beta y rho personalizados
        else if (args.length == 3) {
            fart = new Fart(Double.parseDouble(args[0]), Double.parseDouble(args[1]), Double.parseDouble(args[2]));
        }

        BufferedReader in = new BufferedReader(new InputStreamReader(System.in)) ;
        // Se declara la variable lineaIn y lineaOut que será utilizara para leer datos desde
        // consola y paar escribir datos a consola respectivamente.
        String lineIN = null;
        // Declaración de variables temporales (string) y  la variables (double)
        // que contendran los valores de las coordenadas x e y
        String coordenadas[] = null;
        Double xcoord, ycoord;
        boolean executionFlag = true;
        while (executionFlag) {
            // Si se recibe un linea se verifica que se debe hacer
            if ((lineIN = in.readLine()) != null) {
                // Si se recibe la palabra "close" se termina la ejecución del programa
                if (lineIN.contentEquals("close")) {
                    executionFlag = false;
                    System.exit(0);
                }

                // Si se recibe la palabra "clean" se limpia la matriz de pesos del algoritmo de Fart
                if (lineIN.contentEquals("clean")) {   fart.restart();     }

                // Si el segundo caracter es un punto se asume que se han ingresado
                // correctamente las coordenadas y se ejecuta el algoritmo de Fart,
                // en cualquier otro se vuelve al estado de escucha.
                if (lineIN.startsWith(".", 1)) {
                    coordenadas = lineIN.split(" ");
                    if (coordenadas.length == 2) {
                        xcoord = Double.parseDouble(coordenadas[0]);
                        ycoord = Double.parseDouble(coordenadas[1]);
                        fart.calculation(xcoord, ycoord);
                        fart.printMap();      // Imprime la matriz de pesos en la salida estandar
                    }
                }
            }   // End of else if( (lineIN = in.readLine()) != null) {
            else if( !(lineIN.startsWith("c", 0)) || !(lineIN.startsWith(".", 1))) {
                System.out.println("\nPlease enter only normalized values for the coordinates x and y");
                System.out.println("or close to exit or clean to clean the map.");
                System.out.println("example: 0.005 1.0\n");
            }
        }   // End of while (executionFlag)
        } catch (Exception e) { e.printStackTrace();    }
    }   // End of public static void main(String args[]) {
}   // End of public class FartShell {
